﻿/**
 * Preload Manager
 *
 * @version 	1.0 27 Jan 2005
 * @author 	Aaron Ambrose
 */

class PreloadManager{
	
	private var targetMc:MovieClip;
	private var callBack:String;
	private var callBackPath:Object;
	private var loaderType:Number;
	private var pLoader:Preloader;
	private var loadAnim:LoadAnimation;
	public  var movieWidth:Number;
	public  var movieHeight:Number;
	
	public function PreloadManager() {
		
		
	};
	
	public function startLoad(targetMc:MovieClip, callBack:String, callBackPath:Object, loaderType:Number, movieWidth:Number, movieHeight:Number):Void {

		this.targetMc     = targetMc;
		this.callBack     = callBack;
		this.callBackPath = callBackPath;
		this.loaderType   = loaderType;
		this.movieWidth   = movieWidth;
		this.movieHeight  = movieHeight;
		
		
		if(loaderType == 1 || loaderType == 2 || loaderType == 3){
			
			// attach movie clip to the stage and give it
			// two call back references
			//	1- for starting the load
			//	2- for removing itself			
			_root.attachMovie("preload_animation_" + loaderType, "loaderMc", 1000);
			_root.loaderMc.callBackStart  = "beginLoad";
			_root.loaderMc.callBackStop = "endLoad";
			_root.loaderMc.parentObj     = this;
			
			_root.loaderMc._x = (movieWidth / 2);
			_root.loaderMc._y = (movieHeight / 2);
			return;
		}
			
			
	
		// create an instance of the preload animation class
		// giving it two call back references
		//	1- for starting the load
		//	2- for removing itself
		if(loaderType == 4)
			loadAnim = new LoadAnimation1(this, "beginLoad", "endLoad");
		// if(loaderType == 5)
			// loadAnim = new LoadAnimation2(this, "beginLoad", "endLoad");
	};
	

	public function beginLoad(loadingBar:MovieClip):Void {

		pLoader = new Preloader();
		pLoader.startLoad(targetMc, loadingBar, "closeAnimation", this);
	};
	
	
	public function closeAnimation(Void):Void {
		
		if(loaderType < 4){
			_root.loaderMc.gotoAndPlay("close");
		} else {
			loadAnim.runOut();
		}
	};
	
	
	public function endLoad(Void):Void {

		if(loaderType < 4){
			_root.loaderMc.removeMovieClip();
		} else {
			delete loadAnim;
		}
		
		stopLoad();
	};
	
	
	public function stopLoad() {

		callBackPath[callBack]();
	};
	

	
};